<?php if (!defined('PmWiki')) exit();
/* 
   publish page collection script, version 2.0.41
   Copyright 2003, 2004, 2005 John Rankin john.rankin@affinity.co.nz
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This file turns a trail page into a published book of the contents, in a
   form suitable for printing. Enhances Printable View on each browse page.

*/
Markup('red','>links','/\(:(redirect)\s+(.*?):\)/','<em>$1s to $2</em>');
SDV($PdfMetaTagFmt,"\n<meta type=\"\$MetaType\" value=\"\$MetaValue\" />");
SDVA($PdfFrontMatterPattern, array(
    'surtitle' => 'PrintSurTitleFmt', 'title' => 'PrintHeaderFmt',
    'subtitle' => 'PrintSubTitleFmt'));
SDVA($PublishFormPageFmt, array(
    'search'  => array('$Group.SearchTemplate',  'Site.SearchTemplate'),
    'wikilog' => array('$Group.CalendarTemplate','Site.CalendarTemplate'),
    'typeset' => array('$Group.PublishTemplate', 'Site.PublishTemplate'),
    'book'    => array('$Group.BookTemplate',    'Site.BookTemplate'),
    'print'   => array('$Group.PrintTemplate',   'Site.PrintTemplate'),
    'include' => array('$Group.IncludeTemplate', 'Site.IncludeTemplate')
    ));
$PublishHandler = array(
    'search'  => 'HandleSearchPublish',
    'wikilog' => 'HandleCalendarPublish',
    'typeset' => 'HandlePublish',
    'book'    => 'HandleBookPublish',
    'print'   => 'HandleBrowse',
    'include' => 'HandleBrowse');
$needle   = isset($_GET['needle'])   ? preg_replace('/\x91/','&lsquo;', 
    preg_replace('/\x92/','&rsquo;',$_GET['needle'])) : '';
$haystack = isset($_GET['haystack']) ? preg_replace('/\x91/','&lsquo;',
    preg_replace('/\x92/','&rsquo;',$_GET['haystack'])) : '';
$category = @$_GET['category'] . '';
$page     = @$_GET['page']     . '';
$include  = @$_GET['include']  . '';
$pagearray = isset($_GET['pagearray']) ? $_GET['pagearray'] : 
    (isset($_GET['pages']) ? explode('+',$_GET['pages']) : array());
$order    = @$_GET['order']    . '';
if ($needle) {
    $PublishType = 'search';
} elseif ($category) {
    $PublishType = 'category';
} elseif ($page) {
    if ($include) array_unshift($pagearray,$page);
    $PublishType = 'links';
} elseif (isset($_GET['pages'])) {
    $psort = $_GET['psort'];
    $PublishType = 'pages';
} elseif ($order) {
    $PublishType = 'calendar';
} else {
    $PublishType = 'default';
    SDV($HandleActions['pubtrail'],'HandlePublishChoices');
    if (@$_GET['plain']) $NumberPages = false;
}
if (preg_match('/^tex(search|wikilog|typeset|book|print|include)$/',$action,$m)) {
    $TypesetFor = $m[1];
    $action = 'texoptions';
    SDV($HandleActions['texoptions'],'HandlePublishOptions');
    if ($m[1]=='search') {
        $FmtV['$Needle']   = $needle;
        $FmtV['$Haystack'] = $haystack;
        $FmtV['$Category'] = $category;
        $FmtV['$LinkPage'] = $page;
        $FmtV['$Pages']    = implode('+',$pagearray) . '|' .
          count($pagearray) . ' selected';
        $FmtV['$PSort']    = $psort;
    }
} elseif ($action=="print" || $action=="publish") {
    $PublishSearch = false; $enable_publish = false;
    SDV($ActionSkin[$action], 'html'.$action);
    $ActDescription = ($action=='print') ? 'last modified' : 'collection published';
    if ($action=='publish') {
        $FmtP['/\\$LastModified/e'] = '$GLOBALS[\'CurrentTime\']';
        $wLinkPageFunction = $LinkFunctions['<:page>'];
        $LinkFunctions['<:page>'] = 'LinkPagePublish';
        $AnchorLinkFmt = "<a href='#\$LinkName'>\$LinkText</a>";
        $PublishPageName = $pagename;
        Markup('[[#','<[[','/(?>\\[\\[#([A-Za-z][-.:\\w]*))\\]\\]/e',
          "Keep(\"<a name='\$pagename.$1' id='\$pagename.$1'></a>\",'L')");
        Markup('[[#wp','<[[#','/(?>\\[\\[#(wikipublisher\.[-.:\\w]*))\\]\\]/e',
          "Keep(\"<a name='$1' id='$1'></a>\",'L')");
    } elseif ($include=='include') Markup('showsubpage','fulltext',
   "/(^|\n)([*#]+)\s*([^\n]+)(\n|$)/sei",
   "'$1'.IncludeSubpages(\$pagename, '$2', PSS('$3')).'$4'");
    $GroupHeaderFmt = '(:include $Group.GroupPrintHeader:)(:nl:)';
    $GroupFooterFmt = '(:nl:)(:include $Group.GroupPrintFooter:)';
    $LinkPageExistsFmt = 
      "<a class='wikilink' href='\$PageUrl?action=print'>\$LinkText</a>";
    $LinkPageCreateFmt = 
      "<a class='createlinktext' href='\$PageUrl?action=print'>\$LinkText</a>";
    $LinkPageCreateSpaceFmt = $LinkPageCreateFmt;
    $UrlLinkTextFmt = "<cite>\$LinkText</cite> [<b>\$LinkUrl</b>]";
    $wLinkUrlFunction = $LinkFunctions['http:'];
    $LinkFunctions['http:'] = 'LinkIMapPublish';
    Markup('[[mail','<[[|',
"/\[\[mailto:([^\s$UrlExcludeChars]*[^\s.,?!$UrlExcludeChars])\s*\|\s*(.*?)\]\]/e",
      "Addressee('$2') . ' [' . 
      Keep(Makelink(\$pagename,'mailto:$1','$1'),'L') . ']'");
    Markup('<<|','<links','/&lt;&lt;\\|([^|]+|\\[\\[(.+?)\\]\\])\\|&gt;&gt;/e',
            "MakeTrailHome(\$pagename,'$1')");
    Markup('<|','><<|','/&lt;\\|([^|]+)\\|&gt;/','');
    Markup('^|','<links','/\\^\\|([^|]+)\\|\\^/','');
    Markup('pub','<links','/\(:\*?publish(nodate)?\s*(.*?):\)/','');
    Markup('tex','directives','/\(:typeset\s*(.*?):\)\s*/','');
    Markup('sect','inline','/\[\[#pub(\d+(?:\.\d+)*)\]\]\1&ensp;/',
        '[[#pub$1]]<span class=\'section\'>$1&ensp;</span>');
    $ptype = isset($_GET['ptype']) ? $_GET['ptype'] : $TypesetFor;
    if ($TypesetFor) $TbookMetadataFmt = 
            PublishFormData($pagename,$PublishFormPageFmt[$TypesetFor]);
    if (!($ptype == 'typeset' || $ptype=='book')) {
        if ($format=='pdf') SDVA($TbookMetadataFmt,
            PublishFormDefaults($pagename,$PublishFormPageFmt[$ptype]));
        $FM = FrontMatter($PublishType);
        foreach ($PdfFrontMatterPattern as $k => $v) SDV($$v, $FM[$k]);
    }
    $HandleActions[$action] = $PublishHandler[$ptype];
} 
if ($format=='pdf') {
    $UrlLinkFmt = "<tbook:url name='\$LinkUrl'>\$LinkText</tbook:url>";
    $UrlLinkTextFmt = "<tbook:visual markup='sl'>\$LinkText</tbook:visual>".
        "<tbook:footnote>\$LinkUrl</tbook:footnote>";
    $UrlLinkFootnoteFmt = "<tbook:url name='\$PageUrl'>\$LinkText</tbook:url>";
    SDV($WPLinkPageExistsFmt, "\$LinkText<tbook:visual markup='sup'>" .
        " (<tbook:url name='\$LinkUrl'>w</tbook:url>)</tbook:visual>");
    SDV($WPLinkPageExistsAnchorFmt, 
        str_replace('>w<','>w#$LinkAnchor<',$WPLinkPageExistsFmt));
    SDV($WPLinkPageCreateFmt, 
        "\$LinkText<tbook:url name='\$PageUrl?action=edit'>" .
        '<tbook:visual markup="sup">?</tbook:visual></tbook:url>');
    $LinkPageExistsFmt = $WPLinkPageExistsFmt;
    $LinkPageExistsAnchorFmt = $WPLinkPageExistsAnchorFmt;
    $LinkPageCreateFmt = $WPLinkPageCreateFmt;
    $LinkPageCreateSpaceFmt = $WPLinkPageCreateFmt;
    $LinkPageSelfFmt = "<tbook:visual markup='sc'>\$LinkText</tbook:visual>";
    $LinkPageExistsTitleFmt = $LinkPageExistsFmt;
    $AnchorLinkFmt = "\$LinkText (<tbook:pageref refid='\$LinkName'>p</tbook:pageref>)";
    $IMapLinkFmt['Attach:'] = '$LinkText';
    if ($action=='print') {
        $HeadingDepth[PageVar($pagename,'$FullName')] = 'section';
        $wLinkPageFunction = $LinkFunctions['<:page>'];
        $LinkFunctions['<:page>'] = 'LinkPagePrint';
        SDV($LookForLocalAnchors, 1);
        Markup('texmeta','<tex','/\(:typeset-(?:page|trail)\s+(.*?):\)/e',
            "PZZ(SetPdfMetaTags(PSS('$1'), true))");
        Markup('2col','directives','/\(:(2col)umn:\)/e',
            "AssignMetaTag('fontsize','$1')");
        Markup('tbsecid','>style',
          '/(<tbook:(?:sub)?section)>(<.*?>)?<tbook:wrap\s+(id=[^>]*>)<\/tbook:wrap>/',
          '$1 $3$2');
    }
    Markup('tbhead','block','/^H:(.*)$/',
        '<:block><tbook:heading>$1</tbook:heading>');
    Markup('tbwrap','>style',
      '/^((?:<vspace>)?<tbook:[^>]*)>(<.*?>)?<tbook:wrap\s+(id=[^>]*>)<\/tbook:wrap>/',
      '$1 $3$2');
    $ActionSkin[$action] = 'latex'.$action;
    if ($ptype == 'typeset') SDV($IncludeModifiedDate,false);
    elseif ($ptype == 'book') { 
        $ActionSkin[$action] .= 'book';
        SDV($IncludeModifiedDate,false);
    }
    SDV($NumberPages,false);
}
SDV($IncludeModifiedDate,true);
SDV($NumberPages,true);
SDV($HandlePublishFmt,array(&$PageStartFmt,
                            'markup:(:groupheader:)',
                            &$PublishList,
                            'markup:(:groupfooter:)',
                            &$PageEndFmt));
SDV($PublishPageNotFoundFmt,'Page \'\'$Tlink\'\' does not exist.');
SDV($PublishPageUnauthorisedFmt,'Not authorised to read page \'\'$Tlink\'\'.');

SDV($PublishPageNameFmt,"<a class='wikilink' href='\$PageUrl'>\$Title</a>:");
SDV($PublishPageStyleFmt,"<input type='hidden' name='plain' value='plain' />");
if ($EnablePDF) SDV($PublishPageOptionsFmt,
    " (<a class='wikilink' href='\$PageUrl?action=textypeset'>\$[PDF options]</a>)");
SDV($PublishTagFmt,array(
'typeset' => "<form class='publish' action='\$ScriptUrl' method='get'>
    \$PublishName<input type='hidden' name='n' value='\$FullName' />
    <input type='hidden' name='action' value='publish' />
    <input type='hidden' name='ptype' value='typeset' />\$PublishStyle
    <input type='checkbox' name='include' value='include' checked />$[Include this page]
    $PDFCheckboxFmt$PDFTypesetFmt$PDFOptionsFmt</form>",
'trail' => "<form class='publish' action='\$ScriptUrl' method='get'>
    <input type='hidden' name='n' value='\$FullName' />
    <input type='hidden' name='action' value='print' />
    <input type='hidden' name='ptype' value='include' />
    <input type='checkbox' name='include' value='include' checked />$[Include trail pages]
    $PDFCheckboxFmt".str_replace('Typeset','Typeset page',$PDFTypesetFmt).
    "$PDFOptionsFmt</form>",
'page' => "<form class='publish' action='\$ScriptUrl' method='get'>
    <input type='hidden' name='n' value='\$FullName' />
    <input type='hidden' name='action' value='print' />
    <input type='hidden' name='ptype' value='print' />
    $PDFCheckboxFmt".str_replace('Typeset','Typeset page',$PDFTypesetFmt).
    "$PDFOptionsFmt</form>",
'book' => "<form class='publish' action='\$ScriptUrl' method='get'>
    <input type='hidden' name='n' value='\$FullName' />
    <input type='hidden' name='action' value='publish' />
    <input type='hidden' name='ptype' value='book' />
    $PDFCheckboxFmt".str_replace('Typeset','Typeset book',$PDFTypesetFmt).
    "$PDFOptionsFmt</form>"));
SDV($PdfMetaTagPattern,"([a-z]+)=((?:(['\"])(.*?)\\3)|([[:alnum:]]+))");
SDV($PdfDraftPattern,array(
	'draft=on' => "watermark=draft subtitle='draft version'"));

SDVA($LinkCleanser, array(
    '/`\..*?$/' => '...',
    "/\\{(\\$.*?)\\}/" => '$1',
    "/\\[\\[([^|\\]]+)\\|\\s*(.*?)\\]\\]($SuffixPattern)/e" =>
            "MakeLink(\$pagename,PSS('$1'),PSS('$2'),'$3','\$LinkText')",
    "/\\[\\[([^\\]]+?)\\s*-+&gt;\\s*(.*?)\\]\\]($SuffixPattern)/e" =>
            "MakeLink(\$pagename,PSS('$2'),PSS('$1'),'$3','\$LinkText')",
    '/\\[\\[#([A-Za-z][-.:\\w]*)\\]\\]/' => "",
    "/\\[\\[(.*?)\\]\\]($SuffixPattern)/e" =>
            "MakeLink(\$pagename,PSS('$1'),NULL,'$2','\$LinkText')",
    '/[\\[\\{](.*?)\\|(.*?)[\\]\\}]/' => '$1',
    "/`(($GroupPattern([\\/.]))?($WikiWordPattern))/" => '$1'
            ));

Markup('pub','<links','/\(:(\*)?publish(nodate)?\s*(.*?):\)/e',
   "Keep(FmtPublishName(\$GLOBALS['PublishTagFmt']['typeset'],\$pagename,'\$1','\$3'))");
Markup('pubpg','directives','/\(:(\*)?publish\s+(.*?):\)/e',
    "ValidatePublish(\$pagename,'$1',PSS('$2'))");
Markup('tex','directives','/^\(:typeset(?:-(page|trail|book))?(\s+.*?)?:\)/e',
    "'<:block>'.
     Keep(TypesetButton(\$GLOBALS['PublishTagFmt'][('$1'=='') ? 'typeset' : '$1'],\$pagename)). 
     TypesetSettings(PSS(trim('$2')))");

Markup('trail', '>if', '/^\(:traillinks\s+(?:(publish)=)?(.*?)\s*:\)/ei',
  "PRR().FmtTrailLinks(MakePageName(\$pagename,'$2'), array('action' => '$1'))");
Markup('2col','directives','/\(:2column:\)/','');

function ValidatePublish($pagename,$style,$publishpage) {
  global $GroupPattern,$NamePattern;
  if (!preg_match("/^$GroupPattern([\\/.])$NamePattern\$/",$publishpage,$match))
      $publishpage = FmtPageName('$Group',$pagename)."/$publishpage";
  if (PageExists($publishpage)) 
      return "(:$style"."publish $publishpage:)";
  else return "[[$publishpage]] not found.";
}

function FmtPublishName($fmt,$pagename,$style,$publishpage) {
  global $PublishPageNameFmt,$PublishPageStyleFmt;
  $s = ($style) ? $PublishPageStyleFmt : '';
  if ($publishpage) {
     $r = FmtPageName($PublishPageNameFmt,$publishpage);
     $fmt = str_replace('this','that',$fmt);
  } else {
     $r = '';
     $publishpage = $pagename;
  }
  return str_replace('$PublishName',$r,str_replace('$PublishStyle',$s,
    FmtPageName($fmt,$publishpage)));
}

function PatchTypesetQuotes($text) {
  return preg_replace("/(\d)(['\"])$/","$1`$2",$text);
}

function TypesetSettings($metatags) {
  global $PdfMetaTagPattern,$WikiWordPattern,$PdfDraftPattern;
  if ($metatags=='') return '';
  $metatags = preg_replace("/\\b($WikiWordPattern)/","`$1",$metatags);
  foreach ($PdfDraftPattern as $d => $r) 
		$metatags = str_replace($d,$r,$metatags);
  return "\n<dl class='publish'><dt>Wikipublisher PDF settings</dt>" . 
        preg_replace("/$PdfMetaTagPattern\s*/e",
        "'<dd>\'\'$1:\'\' '.PatchTypesetQuotes(PSS('$2')).'</dd>'",$metatags).
        '</dl>';
}

function TypesetButton($fmt,$pagename) {
  return str_replace('$PublishName','',str_replace('$PublishStyle','',
    FmtPageName($fmt,$pagename)));
}

function FrontMatter($publishtype) {
    global $WikiBookSettings;
    SDVA($WikiBookSettings, array(
        'search' => array(
                    'surtitle' => '$[Wikipublisher]',
                    'title'    => '$[Selected Search Results]',
                    'subtitle' => "$[SearchFor]"
                    ),
        'category' => array(
                    'surtitle' => '$[Wikipublisher]',
                    'title'    => '$[Selected Category Results]',
                    'subtitle' => "$[SearchFor]"
                    ),
        'links'  => array(
                    'surtitle' => '$[Wikipublisher]',
                    'title'    => '$[Selected Page Links]',
                    'subtitle' => '$[From the $WikiTitle]'
                    ),
        'pages'  => array(
                    'surtitle' => '$[Wikipublisher]',
                    'title'    => '$[Selected Search Results]',
                    'subtitle' => '$[Pages from $Groupspaced, sorted by <em>$PSort</em>]'
                    ),
        'calendar' => array(
                    'surtitle' => '$[Wikipublisher]',
                    'title'    => '$[Selected $Groupspaced Entries]',
                    'subtitle' => '$[Pages from the $WikiTitle for $Haystack]'
                    ),
        'default' => array(
                    'surtitle' => '$[Wikipublisher]',
                    'title'    => '$Groupspaced: $Title',
                    'subtitle' => '$[From the $WikiTitle]'
                    )
        ));
    return $WikiBookSettings[$publishtype];
}

function AssignMetaTag($type,$value) {
  global $PdfMetaTagFmt,$HTMLHeaderFmt;
  $HTMLHeaderFmt[$type] = str_replace('$MetaType',$type,
                str_replace('$MetaValue',$value,$PdfMetaTagFmt));
}

function SDVO(&$v,$x) { $v=$x; }

function SetPdfMetaTags($pdftags, $overwrite = false) {
  global $PdfMetaTagFmt,$PdfMetaTagPattern,$PdfDraftPattern,$HTMLHeaderFmt,
    $PdfFrontMatterPattern,$PrintSurTitleFmt,$PrintHeaderFmt,$PrintSubTitleFmt;
  $SDV = $overwrite ? 'SDVO' : 'SDV';
  foreach ($PdfDraftPattern as $d => $r) $pdftags = str_replace($d,$r,$pdftags);
  preg_match_all("/$PdfMetaTagPattern/",$pdftags,$m);
  for ($i=0;$i<count($m[0]);$i++) {
      $content = ($m[4][$i]) ? $m[4][$i] : $m[5][$i];
      if ($PdfFrontMatterPattern[$m[1][$i]]) 
          $SDV($$PdfFrontMatterPattern[$m[1][$i]], $content);
      else
         $SDV($HTMLHeaderFmt[$m[1][$i]], str_replace('$MetaType',$m[1][$i],
                str_replace('$MetaValue',$content,$PdfMetaTagFmt)));
  }
}

function HandlePublish($pagename, $auth = 'read') {
  global $SuffixPattern,$HandlePublishFmt,$PublishPageNotFoundFmt,
    $PublishFormPageFmt,$HTMLHeaderFmt,$PdfFrontMatterPattern,$PageAnchors;
  global $include,$IncludeModifiedDate,$NumberPages,$format,$HeadingDepth;
  global $PrintSurTitleFmt,$PrintHeaderFmt,$PrintSubTitleFmt;
  
  $Tbook = array(
     'section','subsection','subsubsection','paragraph','subparagraph');
  $TbookDir = array('description' => 'abstract', 'keywords' => 'keywords');
  
  $trailname = $pagename;
  $trailpage = RetrieveAuthPage($pagename, $auth, true, READPAGE_CURRENT);
  if (!$trailpage) Abort('?cannot read $pagename');
  PCache($pagename,$trailpage);
    if (strstr($trailpage['text'],'publishnodate:)')) $IncludeModifiedDate = false;
    if (strstr($trailpage['text'],'(:*publish')) $NumberPages = false;
    if ($format=='pdf') {
        $HeadingDepth[$trailname] = $Tbook[1];
        foreach ($TbookDir as $k => $v)
            if (preg_match("/\\(:$k\\s+(.*?):\\)/",$trailpage['text'],$dir))
                array_unshift($HTMLHeaderFmt,"<$v>$dir[1]</$v>");

        if (preg_match("/\\(:typeset\\s+(.*?):\\)/",$trailpage['text'],$pdf))
            SetPdfMetaTags($pdf[1]);
        SDVA($HTMLHeaderFmt,
            PublishFormDefaults($trailname,$PublishFormPageFmt['typeset']));
    }
    $FM = FrontMatter('default');
    foreach ($PdfFrontMatterPattern as $k => $v) SDV($$v, $FM[$k]);
    $dpl = ExtractTrailStops($trailname,$trailpage['text']);
    foreach ($dpl as $k => $v) $$k = $v;
    $counter = array(); $predepth= 0;
    for($i=0;$i<count($pages);$i++) {
      @$counter[$depth[$i]-1]++;
      $num = $counter[0];
      for($j=$depth[$i];$j<$predepth;$j++) $counter[$j] = 0;
      $size = 0;
      for($j=1;$j<$depth[$i];$j++) { $num .= "." . $counter[$j]; $size++; }
      if ($size>3) $size=3;
      
      $anchor = "wikipublisher.$num";
      $toc[] = "[[#$anchor|" . TextOfLink($trailname,$links[$i]) . ']]';

      $num = $NumberPages ? "[[#$anchor]]$num&ensp; " : "[[#$anchor]]";

      if ($format=='pdf') {
          $tbtag = '<'.$Tbook[$depth[$i]-1].'>';
          for($j=$depth[$i];$j<=$predepth;$j++) 
            $tbtag = '</'.$Tbook[$j-1].'>'.$tbtag;
          $PublishList[] = $tbtag;
          $PublishList[] = "markup:H:$num$links[$i]";
      } else {
          $s = str_repeat('-',$size);
          $h = "!%block class='pagehead$depth[$i]'%";
          if ($size==0) $PublishList[] = "markup:$h$num$links[$i]";
          else $PublishList[] = "markup:$h"."[$s$num$links[$i]$s]";
      }      
      $predepth = $depth[$i];

      if ($pages[$i]!="textonly") {
          $PageAnchors[$pages[$i]]  = $anchor;
          $HeadingDepth[$pages[$i]] = $Tbook[$depth[$i]];
          if (PageExists($pages[$i])) 
	       	  $PublishList[] = "function:PrintThisPage $pages[$i]";
          else {
              $replname = TextOfLink($trailname,$links[$i]);
              $PublishList[] = "function:PrintThisText " . 
    ((MakeLink($trailname,"[[$replname]]",NULL,NULL,'$FullName')==$pages[$i]) ?
                $links[$i] : "[[".$pages[$i]."]] ($replname)");
          }
      }
    }

    if ($format=='pdf') {
        $tbtag = '';
        for($j=1;$j<=$predepth;$j++) 
            $tbtag = '</'.$Tbook[$j-1].'>'.$tbtag;
        $PublishList[] = $tbtag;
    }


### trial toc links
if ($include) {
    $count = 0;
    foreach(explode("\n",$trailpage['text']) as $x) {
      if (preg_match("/^(T?[#*:!]+\\s*)(.*)/",$x,$match)) {
          $match[2] = ReformatTrailStop($match[2]);
          if (preg_match("/^(\\[\\[([^|:]*?)(\\|[^\\[\\]]*?(?:\\[.*?\\].*?)?)?\\]\\]($SuffixPattern))/",
      $match[2],$m)) {
            $x = $match[1].str_replace($m[1],$toc[$count],$match[2]);
            $count++;
          } elseif (!strstr($match[1],":")) {
            $ltext = preg_replace('/`\\..*?$/','',$match[2]);
            if ($ltext!='') {
                $x = $match[1].str_replace($ltext,$toc[$count],$match[2]);
                $count++;
            }
          }
      } else $x = preg_replace("/\\{(\\$.*?)\\}/",'$1',$x);
      $line[] = $x;
    }
    if ($format=='pdf') 
        array_unshift($PublishList,array('<summary>',
            'markup:H:[[#wikipublisher.top]][['.$trailname.' | $Title]]',
            'function:PrintText '.implode("\n",$line),
            '</summary>'));
    else
        array_unshift($PublishList,array('markup:[[#wikipublisher.top]]',
            'function:PrintText '.implode("\n",$line)));
} else array_unshift($PublishList,'markup:[[#pubtop]]');
###

  $GLOBALS['PublishList'] = $PublishList;
  PrintFmt($pagename,$HandlePublishFmt);
}

function TitleOfPage($pagename, $pn) {
    global $PCache;
    $pn = MakePageName($pagename, $pn);
    if (!isset($PCache[$pn]['title']))
        PCache($pn, ReadPage($pn, READPAGE_CURRENT));
    return FmtPageName('$Title', $pn);
}

function TextOfLink($trailname, $link) {
  global $SuffixPattern;
  if (preg_match("/^(\\[\\[([^|:]*?)(?:\\|([^\\[\\]]*?(?:\\[.*?\\].*?)?))?\\]\\]($SuffixPattern))/",
  $link,$m)) {
      if (($m[3] = trim($m[3]))=='+') $m[3] = TitleOfPage($trailname, $m[2]);
      return MakeLink($trailname, $m[2], (($m[3]) ? $m[3] : NULL), 
                (($m[4]) ? $m[4] : NULL), '$LinkText');
  } else return CleanText($trailname,$link);
}

function ReformatTrailStop($text) {
    global $SuffixPattern,$GroupPattern,$WikiWordPattern,$LinkWikiWords;
    global $SpaceWikiWords,$AsSpacedFunction,$SpaceWikiWordsFunction;
    SDV($SpaceWikiWordsFunction,$AsSpacedFunction);
    if ($LinkWikiWords) 
        $text = preg_replace("/^($GroupPattern([\\/.]))?($WikiWordPattern)/e",
        "'[[$1'.(($SpaceWikiWords)?$SpaceWikiWordsFunction('$3'):'$3').']]'",
        $text);
    $text = preg_replace("/^\\[\\[([^\\]]*)->([^\\]]*)\\]\\]/",'[[$2|$1]]',
        $text);
    if (preg_match('/^\\[\\[[#!]/',$text)) $text = "`.$text";
    return $text;
}

function ExtractTrailStops($trailname,$trailtext) {
  global $SuffixPattern; $headings = 0;
  foreach(explode("\n",$trailtext) as $x) {
      if (preg_match("/^T?([#*:!]+)\\s*(.*)/",$x,$match)) {
          $match[1] = str_replace(':#',':',$match[1]);
          if (strstr($match[1],'!')) {
              if ($headings==0) $headings = strlen($match[1]);
              $match[1] = '!';
          } elseif ($headings) $match[1].= '!';
          if (strlen($match[1]) > 4) $match[1] = str_repeat($match[1][0],4);
          $match[2] = ReformatTrailStop(preg_replace("/\\{(\\$.*?)\\}/e",
                "FmtPageName('$1',\$trailname)",$match[2]));
          if (preg_match("/^(\\[\\[([^|:]*?)(\\|[^\\[\\]]*?(?:\\[.*?\\].*?)?)?\\]\\]($SuffixPattern))/",
          $match[2],$m)) {
            $depth[] = strlen($match[1]);
            $pages[] = MakePageName($trailname,$m[2]);
            $links[] = $m[1];
          } elseif (!strstr($match[1],":")) {
            $match[2] = preg_replace('/`\\..*?$/','',$match[2]);
            if ($match[2]!='') {
                $depth[] = strlen($match[1]);
                $pages[] = "textonly";
                $links[] = $match[2];
            }
          }
      }
  }
  return array('depth' => $depth, 'pages' => $pages, 'links' => $links);
}

function IncludeSubpages($trailname, $trail, $text) {
  global $PublishPageNotFoundFmt;
  $line = ReformatTrailStop(preg_replace("/\\{(\\$.*?)\\}/e",
                "FmtPageName('$1',\$trailname)",$text));
  if (preg_match("/^\\[\\[([^|:]*?)(\\|[^\\[\\]]*?(?:\\[.*?\\].*?)?)?\\]\\]/",
        $line,$m)) {
    $p = MakePageName($trailname, $m[1]);
    $i = PageExists($p) ? "(:include $p:)" : 
        str_replace('$Tlink',$m[0],$PublishPageNotFoundFmt);
    return str_repeat('!',strlen($trail)).$text."\n$i";
  } else return $trail.$text;
}

function HandleSearchPublish($pagename, $auth = 'read') {
  global $HandlePublishFmt,$SpaceWikiWords,$PageAnchors;
  global $needle,$haystack,$pagearray,$psort,$format,$PublishPageNotFoundFmt;
  $Heading      = ($format=='pdf') ? 'H:' : '!%block class="pagehead2"%';
  $HeadOpen     = ($format=='pdf') ? "h level='3'" : 'h3';
  $HeadClose    = ($format=='pdf') ? '/h' : '/'.$HeadOpen;
  $TitleFmt = ($SpaceWikiWords) ? '$Titlespaced' : '$Title';
  for($i=0;$i<count($pagearray);$i++) {
    $pg = str_replace('/','.',$pagearray[$i]);
    PCache($pg,RetrieveAuthPage($pg,$auth,false,READPAGE_CURRENT));
    $linktext = FmtPageName($TitleFmt,$pg);
    $group = FmtPageName('$Group',$pg);
    if ($group!=@$ogroup) { $line[] = "* $group"; $ogroup = $group; }
    $anchor = "wikipublisher.".($i+1);
    $line[] = "** [[#$anchor|$linktext]]: :+(:para $pg#teaser:)";      
    if ($format=='pdf') $PublishList[] = '<section>';
    $PageAnchors[$pg] = $anchor;
    $PublishList[] = "markup:$Heading"."[[#$anchor]][[$pg|$linktext]]";
    $PublishList[] = PageExists($pg) ? "function:PrintThisPage $pg" :
#        "markup:" . str_replace('$Tlink',"[[$pg]]",$PublishPageNotFoundFmt);
        "function:PrintThisText [[$pg]]";
    if ($format=='pdf') $PublishList[] = '</section>';
  }
  if (count($pagearray)==0) 
      $PublishList[] = "<$HeadOpen>$[No pages selected]<$HeadClose>";
  elseif ($format=='pdf') 
      array_unshift($PublishList,array('<summary>',
          'markup:H:[[#wikipublisher.top]]$[Summary]',
          'function:PrintText '.implode("\n\n",$line),
          '</summary>'));
  else
      array_unshift($PublishList,array('markup:[[#wikipublisher.top]]',
          'function:PrintText '.implode("\n\n",$line)));
  $GLOBALS['PublishList'] = $PublishList;
  $GLOBALS['Needle']   = $needle;
  $GLOBALS['Haystack'] = $haystack;
  $GLOBALS['PSort']    = $psort;
  PrintFmt($pagename,$HandlePublishFmt);
}

function CleanText($pagename,$text) {
  global $LinkCleanser;
  foreach ($LinkCleanser as $p => $c) $text = preg_replace($p,$c,$text);
  return $text;
}

function MakeTrailHome($pagename,$trailname) {
  global $SpaceWikiWords,$AsSpacedFunction,$SpaceWikiWordsFunction;
  global $GroupPattern,$WikiWordPattern,$PublishPageName;
  $t = $trailname;
  if (preg_match('/^\\[\\[(.+?)(-&gt;|\\|)(.+?)\\]\\]$/', $trailname, $m)) 
    $trailname = ($m[2] == '|') ? $m[3] : $m[1];
  else
    $trailname = preg_replace("/^($GroupPattern([\\/.]))?($WikiWordPattern)/e",
    "'$1'.(($SpaceWikiWords)?$SpaceWikiWordsFunction('$3'):'$3')",$trailname);
  return (MakePageName($pagename,$trailname)==$PublishPageName) ?
    "[[#wikipublisher.top | $trailname]]" : $t;
}

function PrintText($pagename,$text) {
  echo MarkupToHTML($pagename,$text);
}

function PrintThisPage($pagename,$wikipage=NULL) {
  global $IncludeModifiedDate, $PublishPageUnauthorisedFmt, $TimeFmt, 
         $HeadingDepth;
  if (is_null($wikipage)) $wikipage=$pagename;
  $page = RetrieveAuthPage($wikipage,"read",false,READPAGE_CURRENT);
  if ($page) {
    $GLOBALS['pagename'] = $wikipage;
    SDV($HeadingDepth[$wikipage], 'subsection'); 
    SetInterMapUrls($wikipage);
    if ($IncludeModifiedDate) 
        $page['text'] .= "\n\n(".strftime($TimeFmt,$page['time']).")";
    echo MarkupToHTML($wikipage,$page['text']);
    $GLOBALS['pagename'] = $pagename;
  } else echo MarkupToHTML($wikipage,
            str_replace('$Tlink',$wikipage,$PublishPageUnauthorisedFmt));
}

function PrintThisText($pagename,$wikipage=NULL) {
  global $PublishPageNotFoundFmt, $HeadingDepth, $FmtV, $PageCounter, 
         $MaxPageCount; 
  SDV($PageCounter,0); SDV($MaxPageCount,45);
  $PageCounter++;
  if ($PageCounter==$MaxPageCount) $PublishPageNotFoundFmt = 'Found $Name';
  if (is_null($wikipage)) $wikipage=$pagename;
  $FmtV['$Tlink'] = $wikipage;
  $wikipage = MakeLink($pagename,$wikipage,NULL,NULL,'$FullName');
  $GLOBALS['pagename'] = $wikipage;
  SDV($HeadingDepth[$wikipage], 'subsection'); 
  echo MarkupToHTML($wikipage,FmtPageName($PublishPageNotFoundFmt,$wikipage));
  $GLOBALS['pagename'] = $pagename;
}

function SetInterMapUrls($page) {
  global $UploadUrlFmt,$UploadPrefixFmt,$InterMapUrls;
  $InterMapUrls['Attach'] = 
        FmtPageName("$UploadUrlFmt$UploadPrefixFmt$1",$page);
}

function PrintEndnotes($pagename,$urltext) {
  $etext = Endnote('',$urltext);
  if ($etext!="") echo MarkupToHTML($pagename,$etext);
}

function Endnote($imap,$urltext) {
  global $format,$UrlLinkFootnoteFmt;
  static $endcount, $endtext;
  if ($urltext == "#") {
     $r = "$endtext";
     if ($endcount>0) $r = "!Links\n$r";
     $endcount = 0;
     $endtext = '';
  } else {
     $endcount++;
     $urltext = stripslashes($urltext);
     $txt = preg_replace('/^\\/\\/(.*?)\\/?$/',"$1",$urltext);
     if ($format=='pdf') {
# sick hack: LaTeX dislikes # in a url in a footnote
        $urltext = preg_replace('/#[^#]+$/','',$urltext);
# it also dislikes very long url text
        if (strlen($txt)>90) 
            return substr($txt,0,44) . ' &hellip; ' . substr($txt,-44);
        return str_replace('$PageUrl',"$imap$urltext",
            str_replace('$LinkText',$txt,$UrlLinkFootnoteFmt));
     }
     $r = "<a href='#end$endcount'>$endcount</a>";
     $endtext .= "# [[#end$endcount]] [[$imap$urltext | $txt]]\n";
  }
  return $r;
}

function LinkIMapPublish($pagename,$imap,$path,$title,$txt,$fmt=NULL) {
  global $ImgExtPattern,$UrlLinkTextFmt,$wLinkUrlFunction;
  if (strstr("$imap$path",$txt) || preg_match("/$ImgExtPattern\$/",$path)) 
      return $wLinkUrlFunction($pagename,$imap,$path,$title,$txt,$fmt);
  return str_replace('$LinkUrl',Endnote($imap,$path),
            str_replace('$LinkText',$txt,$UrlLinkTextFmt));
}

function LinkPageTrapAnchor($pagename,$imap,$path,$title,$txt,$fmt=NULL) {
# sick hack: LaTeX dislikes # in a url with text
    global $wLinkPageFunction,$LinkPageExistsAnchorFmt;
    if (preg_match('/^([^#?]+)#([^#]+)$/',$path,$m)) {
        $path = $m[1];
        $fmt  = str_replace('$LinkAnchor',$m[2],$LinkPageExistsAnchorFmt);
    }
    return $wLinkPageFunction($pagename,$imap,$path,$title,$txt,$fmt);
}

function LinkPagePublish($pagename,$imap,$path,$title,$txt,$fmt=NULL) {
    global  $wLinkPageFunction,$UrlExcludeChars,$PageAnchors,$AnchorLinkFmt,
        $PublishPageName,$format;
    if ($fmt!='') 
        return $wLinkPageFunction($pagename,$imap,$path,$title,$txt,$fmt);
    $LinkPageFunction = ($format=='pdf') ? 'LinkPageTrapAnchor' :
        $wLinkPageFunction;
    if (preg_match("/^([^#?]+)(?:#([^\\s$UrlExcludeChars]*))?$/",$path,$m)) {
        if ($pagename == $PublishPageName)
           return $LinkPageFunction($pagename,$imap,$path,$title,$txt,$fmt); 
        $tgtname = MakePageName($pagename,$m[1]); $anch=@$m[2];
        if ($tgtname != $pagename && $PageAnchors[$tgtname]) {
            $anchor = ($anch) ? "$tgtname.$anch" : $PageAnchors[$tgtname];
            return str_replace('$LinkName',$anchor,str_replace('$LinkText',$txt,
                $AnchorLinkFmt));
        }
    } elseif ($path{0} == '#') {
        $path = preg_replace("/[^-.:\\w]/", '', $path);
        $anchor = (preg_match('/^wikipublisher\./',$path)) ? "$path" : 
            "$pagename.$path";
        return str_replace('$LinkName',$anchor,str_replace('$LinkText',$txt,
            $AnchorLinkFmt));
    }
    return $LinkPageFunction($pagename,$imap,$path,$title,$txt,$fmt);
}

function LinkPagePrint($pagename,$imap,$path,$title,$txt,$fmt=NULL) {
    global  $wLinkPageFunction,$AnchorLinkFmt,$format,$LookForLocalAnchors;
    if ($fmt!='') 
        return $wLinkPageFunction($pagename,$imap,$path,$title,$txt,$fmt);
    if (preg_match("/^([^#?]+)(#.+)$/",$path,$m)) {
        $p = MakePageName($pagename,$m[1]);
        if ($LookForLocalAnchors && $p==$pagename) $path = $m[2];
    }
    if ($path{0} == '#') {
        $path = preg_replace("/[^-.:\\w]/", '', $path);
        return str_replace('$LinkName',"$pagename.$path",
            str_replace('$LinkText',$txt,$AnchorLinkFmt));
    }
    $LinkPageFunction = ($format=='pdf') ? 'LinkPageTrapAnchor' :
        $wLinkPageFunction;
    return $LinkPageFunction($pagename,$imap,$path,$title,$txt,$fmt);
}

function Addressee($name) {
  global $WikiWordPattern, $format;
  $em = 'em';
  if ($format=='pdf') $em = "tbook:$em";
  $r = preg_replace("/($WikiWordPattern)/","`$1",$name);
  return "<$em>$r</$em>";
}

function HandlePublishOptions($pagename, $auth='read') {
  global $HandlePublishOptionsFmt,$PageStartFmt,$PublishOptionsFmt,$PageEndFmt,
    $PublishFormPageFmt,$TypesetFor,$FmtP,$PdfDraftPattern;
  $page = RetrieveAuthPage($pagename,$auth,false,READPAGE_CURRENT);
  $opt = Array();
  if (preg_match('/^(typeset|print|include|book)$/',$TypesetFor)) {
      $TypesetMatch = 
          array('typeset' => '', 'print' => '-page', 'include' => '-trail',
                'book' => '-book');
      $typeset = 'typeset'.$TypesetMatch[$TypesetFor];
      if (preg_match("/\\(:$typeset\\s+(.*?):\\)/",$page['text'],$m)) {
          $tags = $m[1];
          foreach ($PdfDraftPattern as $d => $r) $tags=str_replace($d,$r,$tags);
          $opt = ParseArgs($tags);
      }
      if ($TypesetFor=='print' && strstr($page['text'],'(:2column:)'))
          $opt['fontsize'] = '2col|2 column';
  } 
  PCache($pagename,$page);
  $FmtP['/\\$LastModified/e'] = '$GLOBALS[\'CurrentTime\']';
  SDV($HandlePublishOptionsFmt,
    array(&$PageStartFmt,&$PublishOptionsFmt,&$PageEndFmt));
  $PublishOptionsFmt = 
    EntryForm($pagename,$TypesetFor.(($TypesetFor=='print')?'print':'publish'),
    'get',$PublishFormPageFmt[$TypesetFor],$opt);
  PrintFmt($pagename,$HandlePublishOptionsFmt);
}

function PublishFormData($pagename,$FormPageFmt) {
  global $PdfMetaTagFmt,$PdfFrontMatterPattern,
    $PrintSurTitleFmt,$PrintHeaderFmt,$PrintSubTitleFmt;
  $f = FormFields($pagename,$FormPageFmt); $meta = array();
  for($i=0;$i<count($f);$i++)
    if (isset($_REQUEST[$f[$i]['element']]) && $f[$i]['elist']!='-')
        if ($f[$i]['elist']=='+') $meta[$f[$i]['element']] = 
            str_replace('$MetaType',$f[$i]['element'],str_replace('$MetaValue',
                $_REQUEST[$f[$i]['element']],$PdfMetaTagFmt)); 
        else $$PdfFrontMatterPattern[$f[$i]['element']] = 
                str_replace('$', '&#036;', 
                htmlspecialchars(stripmagic($_REQUEST[$f[$i]['element']]),
                ENT_NOQUOTES)); 
  return $meta;
}

function PublishFormDefaults($pagename,$FormPageFmt) {
  global $PdfMetaTagFmt,$PdfFrontMatterPattern,
    $PrintSurTitleFmt,$PrintHeaderFmt,$PrintSubTitleFmt;
  $f = FormFields($pagename,$FormPageFmt); $meta = array();
  for($i=0;$i<count($f);$i++)
      if ($f[$i]['elist']=='+') {
          $f[$i]['etype'] = str_replace(',',';',$f[$i]['etype']);
          $metacontent = (preg_match('/\\*([^;\\|]+)/',$f[$i]['etype'],$m)) ? 
                $m[1] : '';
          if ($metacontent != '') $meta[$f[$i]['element']] = 
             str_replace('$MetaType',$f[$i]['element'],str_replace('$MetaValue',
                $metacontent,$PdfMetaTagFmt));
      } elseif (preg_match('/^"(.*?)"/',$f[$i]['etype'],$m))
            SDV($$PdfFrontMatterPattern[$f[$i]['element']],$m[1]);
  return $meta;
}

function HandlePublishChoices($pagename) {
  global $HandlePublishChoicesFmt,$PageStartFmt,$PublishChoicesFmt,$PageEndFmt,
    $LinkPageCheckFmt,$HTMLVSpace,$PDFCheckboxFmt,$PDFTypesetFmt,$PDFOptionsFmt,
    $HPCTitleFmt;
  SDV($HandlePublishChoicesFmt,
    array(&$PageStartFmt,&$PublishChoicesFmt,&$PageEndFmt));
  SDV($HPCTitleFmt,
    "<h1 class='wikiaction'>$[Trail on] <a href='\$PageUrl'>\$Group: \$Title</a></h1>");
  $HPCStartFmt =
    "<form class='pubchoice' action='\$ScriptUrl' method='get'>
    <input type='hidden' name='n' value='\$FullName' />";
  $HPCEndFmt = "$HTMLVSpace
    <input type='hidden' name='page' value='\$FullName' />
    <input class='publish' type='checkbox' name='include' value='include' checked />$[Include this page]
    <input type='hidden' name='action' value='publish' />
    <input type='hidden' name='ptype' value='search' />
    $PDFCheckboxFmt$PDFTypesetFmt$PDFOptionsFmt</form>";
  $PublishChoicesFmt = array(
                $HPCTitleFmt,
                $HTMLVSpace,
                $HPCStartFmt,
                'markup:(:traillinks publish=$FullName:)',
                $HPCEndFmt);
  $LinkPageCheckFmt = 
      "<input type='checkbox' name='pagearray[]' value='\$Group/\$Name' />";
  Markup('check','<links','/\(:checkbox\s+(.*?):\)/e',
      "Keep(FmtPageName(\$GLOBALS['LinkPageCheckFmt'],'$1'))");
  PrintFmt($pagename,$HandlePublishChoicesFmt);
}

function FmtTrailLinks($pagename,$opt) {
  $trailname = $pagename;
  $trailpage = RetrieveAuthPage($pagename, "read", false, READPAGE_CURRENT);
  PCache($trailname,$trailpage);
  $dpl = ExtractTrailStops($trailname,$trailpage['text']); $line = array();
  foreach ($dpl as $k => $v) $$k = $v;
  for($i=0;$i<count($pages);$i++) {
    if ($opt['action']=='publish' && $pages[$i]!='textonly')
        $links[$i] = "(:checkbox $pages[$i]:) " . $links[$i];
    $line[] = str_repeat('*',$depth[$i]).$links[$i];
  }
  return implode("\n",$line);
}

?>